
#ifndef __REGS_H__
#define __REGS_H__


//#include "GB_mem.h"

/* General internal/io stuff */

#define RI_P1    0x100
#define RI_SB    0x101
#define RI_SC    0x102
#define RI_DIV   0x104
#define RI_TIMA  0x105
#define RI_TMA   0x106
#define RI_TAC   0x107

#define RI_KEY1  0x14D

#define RI_RP    0x156

#define RI_SVBK  0x170



/* Interrupts flags */

#define RI_IF    0x10F
#define RI_IE    0x1FF




/* LCDC */

#define RI_LCDC  0x140
#define RI_STAT  0x141
#define RI_SCY   0x142
#define RI_SCX   0x143
#define RI_LY    0x144
#define RI_LYC   0x145
#define RI_DMA   0x146
#define RI_BGP   0x147
#define RI_OBP0  0x148
#define RI_OBP1  0x149
#define RI_WY    0x14A
#define RI_WX    0x14B

#define RI_VBK   0x14F

#define RI_HDMA1 0x151
#define RI_HDMA2 0x152
#define RI_HDMA3 0x153
#define RI_HDMA4 0x154
#define RI_HDMA5 0x155

#define RI_BCPS  0x168
#define RI_BCPD  0x169
#define RI_OCPS  0x16A
#define RI_OCPD  0x16B



/* Sound */

#define RI_NR10 0x110
#define RI_NR11 0x111
#define RI_NR12 0x112
#define RI_NR13 0x113
#define RI_NR14 0x114
#define RI_NR21 0x116
#define RI_NR22 0x117
#define RI_NR23 0x118
#define RI_NR24 0x119
#define RI_NR30 0x11A
#define RI_NR31 0x11B
#define RI_NR32 0x11C
#define RI_NR33 0x11D
#define RI_NR34 0x11E
#define RI_NR41 0x120
#define RI_NR42 0x121
#define RI_NR43 0x122
#define RI_NR44 0x123
#define RI_NR50 0x124
#define RI_NR51 0x125
#define RI_NR52 0x126



#define REG(n) gb_cpu.himem[(n)]



/* General internal/io stuff */

#define R_P1    REG(RI_P1)
#define R_SB    REG(RI_SB)
#define R_SC    REG(RI_SC)
#define R_DIV   REG(RI_DIV)
#define R_TIMA  REG(RI_TIMA)
#define R_TMA   REG(RI_TMA)
#define R_TAC   REG(RI_TAC)

#define R_KEY1  REG(RI_KEY1)

#define R_RP    REG(RI_RP)

#define R_SVBK  REG(RI_SVBK)



/* Interrupts flags */

#define R_IF    REG(RI_IF)
#define R_IE    REG(RI_IE)




/* LCDC */

#define R_LCDC  REG(RI_LCDC)
#define R_STAT  REG(RI_STAT)
#define R_SCY   REG(RI_SCY)
#define R_SCX   REG(RI_SCX)
#define R_LY    REG(RI_LY)
#define R_LYC   REG(RI_LYC)
#define R_DMA   REG(RI_DMA)
#define R_BGP   REG(RI_BGP)
#define R_OBP0  REG(RI_OBP0)
#define R_OBP1  REG(RI_OBP1)
#define R_WY    REG(RI_WY)
#define R_WX    REG(RI_WX)

#define R_VBK   REG(RI_VBK)

#define R_HDMA1 REG(RI_HDMA1)
#define R_HDMA2 REG(RI_HDMA2)
#define R_HDMA3 REG(RI_HDMA3)
#define R_HDMA4 REG(RI_HDMA4)
#define R_HDMA5 REG(RI_HDMA5)

#define R_BCPS  REG(RI_BCPS)
#define R_BCPD  REG(RI_BCPD)
#define R_OCPS  REG(RI_OCPS)
#define R_OCPD  REG(RI_OCPD)



/* Sound */

#define R_NR10 REG(RI_NR10)
#define R_NR11 REG(RI_NR11)
#define R_NR12 REG(RI_NR12)
#define R_NR13 REG(RI_NR13)
#define R_NR14 REG(RI_NR14)
#define R_NR21 REG(RI_NR21)
#define R_NR22 REG(RI_NR22)
#define R_NR23 REG(RI_NR23)
#define R_NR24 REG(RI_NR24)
#define R_NR30 REG(RI_NR30)
#define R_NR31 REG(RI_NR31)
#define R_NR32 REG(RI_NR32)
#define R_NR33 REG(RI_NR33)
#define R_NR34 REG(RI_NR34)
#define R_NR41 REG(RI_NR41)
#define R_NR42 REG(RI_NR42)
#define R_NR43 REG(RI_NR43)
#define R_NR44 REG(RI_NR44)
#define R_NR50 REG(RI_NR50)
#define R_NR51 REG(RI_NR51)
#define R_NR52 REG(RI_NR52)



#endif





