
#ifndef _NES_ONLY


#include <windows.h>
#include <shlwapi.h>
#include <mmsystem.h>
#include "win32_GB_emu.h"
#include "win32_directinput_input_mgr.h"
#include "win32_timing.h"
#include "mkutils.h"
#include "debug.h"
#include "NES_settings.h"
#include "win32_screen_mgr.h"
#include "gnuboy.h"
#include "GB_pad.h"
#include "win32_GB_emu.h"

#include "savecfg.h"
#include "resource.h"
#include "extra_window.h"


extern void MyCtRestore();			//Cheat
extern void SocketClose();
extern int MovieAddedDialog();

//#include "recavi.h"

#include <dinput.h>

#define PROFILE

#define SPEED_THROTTLE

#define SPEED_THROTTLE_KEY  VK_ADD

// these read the keyboard asynchronously
#define KEY_DOWN(vk_code) ((GetAsyncKeyState(vk_code) & 0x8000) ? 1 : 0)
#define KEY_UP(vk_code)   ((GetAsyncKeyState(vk_code) & 0x8000) ? 0 : 1)

//extern char usedispfpsf;
extern int nnnKailleraFlag;
extern win32_screen_mgr* gscr_mgr;
extern win32_directinput_input_mgr* ginp_mgr;
extern win32_directsound_sound_mgr* g_snd_mgr;
extern uint8 netplay_status;
extern void InfoDisplayt(char *, unsigned int );
//extern struct Preview_state g_Preview_State;
//extern int g_PreviewMode;





#define NTSC_FRAMERATE (60000.0/1001.0)
//#define STD_FRAME_PERIOD   (1000.0/NTSC_FRAMERATE)
#define PAL_FRAMERATE  (50000.0/1001.0)

#define THROTTLE_SPEED  (NESTER_settings.nes.preferences.speed_throttling/* && KEY_UP(SPEED_THROTTLE_KEY)*/)
#define SKIP_FRAMES     (NESTER_settings.nes.preferences.auto_frameskip && THROTTLE_SPEED)

static double StdFramePeriodTime;
static double FastFramePeriodTime;


win32_GB_emu::win32_GB_emu(HWND parent_window_handle, HINSTANCE parent_instance_handle, const char* ROM_name)
{
	parent_wnd_handle = parent_window_handle;
	scr_mgr = NULL;
	inp_mgr = NULL;
	snd_mgr = &local_null_snd_mgr;
	emu = NULL;

	win32_pad1 = NULL;
	win32_pad2 = NULL;
	win32_pad3 = NULL;
	win32_pad4 = NULL;
	pad_bit[0]=pad_bit[1]=pad_bit[2]=pad_bit[3]=pad_bit[4]=pad_bit[5]=0;
	win32_extkey = NULL;		//nnn
	IsFastFPS = FALSE;
	UserPause = FALSE;
	SYS_TimeInit();

	frames_this_sec = 0;
	skipframes_this_sec = 0;
	recaviflag=0;


	try {
		scr_mgr = gscr_mgr->Get_GB_Screenmgr();
		if(scr_mgr==NULL)
			throw;// "";
		inp_mgr=ginp_mgr;
		if(inp_mgr==NULL)
			throw;
		// get a null sound mgr
		snd_mgr = &local_null_snd_mgr;

		try {
			emu = new GAMEBOY(ROM_name,scr_mgr,snd_mgr,parent_window_handle);
		} catch(...) {
			throw;// "error creating emulated NES";
		}

		SetFrameSpeed();
		scr_mgr->StartEmu();

		CreateWin32Pads();
		CreateWin32Extkey();

		// start the timer off right
		reset_last_frame_time();
		last_profile_sec_time=SYS_TimeInMilliseconds();

		// try to init dsound if appropriate
		enable_sound(NESTER_settings.nes.sound.enabled);

		// set up control pads
		emu->set_pad(pad_bit);

	} catch(...) {
		// careful of the order here
		DeleteWin32Extkey();
		DeleteWin32Pads();
		if(emu) delete emu;
		scr_mgr->EndEmu();
		//    if(scr_mgr) delete scr_mgr;
		//    if(inp_mgr) delete inp_mgr;
		if(snd_mgr != &local_null_snd_mgr){
			snd_mgr->freeze();
			snd_mgr->clear_buffer();
		}
		throw;
	}
}

win32_GB_emu::~win32_GB_emu()
{
	DeleteWin32Extkey();
	DeleteWin32Pads();
	if(emu) delete emu;
	if(scr_mgr){ scr_mgr->EndEmu(); scr_mgr->end_avirec(); }
	//  if(scr_mgr) delete scr_mgr;
	//	if(inp_mgr) delete inp_mgr;
	if(snd_mgr != &local_null_snd_mgr){
		snd_mgr->freeze();
		snd_mgr->clear_buffer();
		snd_mgr->end_sndrec();
	}
#if 0
	if(recaviflag){
		recavifilerelease();
	}
#endif
}

void win32_GB_emu::PollInput(float gt)
{
#if 0
	// if we don't have the input focus, release all buttons
	if(GetForegroundWindow() != parent_wnd_handle)
	{
		pad1.release_all_buttons();
		pad2.release_all_buttons();
		pad3.release_all_buttons();
		pad4.release_all_buttons();
		return;
	}
#endif

	{
		inp_mgr->Poll();

		if(win32_pad1){
			win32_pad1->Poll(gt);
			pad_bit[0] = pad1.get_inp_state();
		}
		if(win32_pad2){
			win32_pad2->Poll(gt);
			pad_bit[1] = pad2.get_inp_state();
		}
		if(win32_pad3){ win32_pad3->Poll(gt);
			pad_bit[2] = pad3.get_inp_state();
		}
		if(win32_pad4){
			win32_pad4->Poll(gt);
			pad_bit[3] = pad4.get_inp_state();
		}
	}
}


void win32_GB_emu::input_settings_changed()
{
	DeleteWin32Pads();
	CreateWin32Pads();
	DeleteWin32Extkey();			//nnn
	CreateWin32Extkey();
}

void win32_GB_emu::CreateWin32Pads()
{
	win32_directinput_input_mgr* win32_inp_mgr;

	DeleteWin32Pads();

	win32_inp_mgr = (win32_directinput_input_mgr*)inp_mgr; // naughty

	try {
		win32_pad1 = new win32_GB_pad(&NESTER_settings.nes.input.player1, &pad1, win32_inp_mgr);
	} catch(const char* IFDEBUG(s)) {
		LOG("Error creating pad 1 - " << s << endl);
		win32_pad1 = NULL;
	}

	try {
		win32_pad2 = new win32_GB_pad(&NESTER_settings.nes.input.player2, &pad2, win32_inp_mgr);
	} catch(const char* IFDEBUG(s)) {
		LOG("Error creating pad 2 - " << s << endl);
		win32_pad2 = NULL;
	}

	try {
		win32_pad3 = new win32_GB_pad(&NESTER_settings.nes.input.player3, &pad3, win32_inp_mgr);
	} catch(const char* IFDEBUG(s)) {
		LOG("Error creating pad 3 - " << s << endl);
		win32_pad3 = NULL;
	}

	try {
		win32_pad4 = new win32_GB_pad(&NESTER_settings.nes.input.player4, &pad4, win32_inp_mgr);
	} catch(const char* IFDEBUG(s)) {
		LOG("Error creating pad 4 - " << s << endl);
		win32_pad4 = NULL;
	}
}

void win32_GB_emu::DeleteWin32Pads()
{
	if(win32_pad1)
	{
		delete win32_pad1;
		win32_pad1 = NULL;
	}
	if(win32_pad2)
	{
		delete win32_pad2;
		win32_pad2 = NULL;
	}
	if(win32_pad3)
	{
		delete win32_pad3;
		win32_pad3 = NULL;
	}
	if(win32_pad4)
	{
		delete win32_pad4;
		win32_pad4 = NULL;
	}
}

//nnn
void win32_GB_emu::CreateWin32Extkey()
{
	win32_directinput_input_mgr* win32_inp_mgr;

	DeleteWin32Extkey();

	win32_inp_mgr = (win32_directinput_input_mgr*)inp_mgr; // naughty

	try {
		win32_extkey = new win32_EXT_key(NESTER_settings.nes.input.extkeycfg, win32_inp_mgr);
	} catch(const char* IFDEBUG(s)) {
		LOG("Error creating extkey - " << s << endl);
		win32_extkey = NULL;
	}
}

void win32_GB_emu::DeleteWin32Extkey()
{
	if(win32_extkey)
	{
		delete win32_extkey;
		win32_extkey = NULL;
	}
}

boolean win32_GB_emu::emulate_frame(boolean draw)
{
	return emu->emulate_frame(draw);
}
/*
boolean win32_GB_emu::emulate_frame_debug(boolean draw)
{
//	return emu->emulate_frame_debug(draw);
	return 0;
}
*/
void win32_GB_emu::freeze()
{
	if(!frozen()) emu->freeze();
}

void win32_GB_emu::thaw()
{
	if(frozen())
	{
		emu->thaw();
		reset_last_frame_time();
	}
}

void win32_GB_emu::reset_last_frame_time()
{
	last_frame_time = SYS_TimeInMilliseconds();

#ifdef PROFILE
	last_profile_sec_time = cur_time;
	frames_this_sec = 0;
#endif

}

const char* win32_GB_emu::getROMname()
{
	const char* name;

	name = emu->getROMname();

	return name;
}

const char* win32_GB_emu::getROMpath()
{
	const char* path;

	path = emu->getROMpath();

	return path;
}

boolean win32_GB_emu::loadState(const char* fn)
{
	boolean result;

	freeze();
	result = emu->loadState(fn);
	thaw();

	return result;
}

boolean win32_GB_emu::saveState(const char* fn)
{
	boolean result;

	freeze();
	result = emu->saveState(fn);
	thaw();

	return result;
}

void win32_GB_emu::reset(unsigned char sr)
{
	freeze();
	emu->reset(sr);
	thaw();
}

void win32_GB_emu::blt()
{
	scr_mgr->blt();
}

void win32_GB_emu::flip()
{
	scr_mgr->flip();
}

void win32_GB_emu::assert_palette()
{
//	scr_mgr->assert_palette();
}

/*
boolean win32_GB_emu::toggle_fullscreen()
{
  return scr_mgr->toggle_fullscreen();
}
*/
void win32_GB_emu::sound_settings_changed()
{
	snd_mgr = &local_null_snd_mgr;
	enable_sound(NESTER_settings.nes.sound.enabled);
}


void win32_GB_emu::enable_sound(boolean enable)
{
//	return;
	freeze();

	if(snd_mgr != &local_null_snd_mgr)
	{
		snd_mgr->freeze();
		snd_mgr = &local_null_snd_mgr;
	}

	if(enable)
	{
		snd_mgr = g_snd_mgr->set_stereo();
	}
	((GAMEBOY*)emu)->new_snd_mgr(snd_mgr);
	snd_mgr->thaw();

	thaw();
}

boolean win32_GB_emu::sound_enabled()
{
	return !snd_mgr->IsNull();
}

boolean win32_GB_emu::set_sample_rate(int sample_rate)
{
	if(!sound_enabled()) return FALSE;
	if(get_sample_rate() == sample_rate) return TRUE;
	return TRUE;
}

int win32_GB_emu::get_sample_rate()
{
	return snd_mgr->get_sample_rate();
}

// STATIC FUNCTIONS
#if 1
static inline void SleepUntil(long time)
{
	if(!NESTER_settings.nes.preferences.NotUseSleep){
//		timeBeginPeriod(1);
		long timeleft = time - (long)(SYS_TimeInMilliseconds());
		if( timeleft > 2)			//if( timeleft > 2)
		{
			Sleep( timeleft - 1 );
		}
		while( time - (long)(SYS_TimeInMilliseconds()) > 0 )
			Sleep(0);
//		timeEndPeriod(1);
	}
	else{
//		MSG      msg;
		while(1){
			long timeleft = time - (long)(SYS_TimeInMilliseconds());
			if(timeleft <= 1)
				break;
/*
			if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
				if(msg.message == WM_QUIT)
					return;
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
*/
		}
	}
}

#else
static inline void SleepUntil(long time)
{
	long timeleft;

	while(1)
	{
		timeleft = time - long(SYS_TimeInMilliseconds());
		if(timeleft <= 0) break;

		if(timeleft > 2)
		{
			Sleep((timeleft) - 1);
		}
	}
}
#endif
/*
When the NTSC standard was designed, certain frequencies involved
in the color subcarrier were interfering with the 60 Hz power lines.  So
the NTSC engineers set the framerate to 60000/1001 Hz.  See also
"drop frame timecode" on any search engine for the full story.
*/


void win32_GB_emu::do_frame()
{
	uint32 frames_since_last, i, skip_frameflag;

	if(frozen()) return;

	cur_time = SYS_TimeInMilliseconds();

	skip_frameflag = (SKIP_FRAMES && !nnnKailleraFlag && !netplay_status);

//	if(SKIP_FRAMES && !nnnKailleraFlag && !netplay_status)  //&&!(IsFastFPS)
	{
		if(IsFastFPS){
			if(NESTER_settings.nes.preferences.FastSpeedState==0){		//FPS
				FramePeriod = FastFramePeriodTime;
				frames_since_last = (uint32)((cur_time - last_frame_time) / FramePeriod );
			}
			else if(NESTER_settings.nes.preferences.FastSpeedState==1){	//SkipFrame
				FramePeriod = FastFramePeriodTime;
				if(skip_frameflag)
				{
					for(i=0;i<NESTER_settings.nes.preferences.FastSkipFrame;++i){
						emulate_frame(FALSE);
						skipframes_this_sec++;
					}
				}
				frames_since_last = 0;
			}
			else{
				frames_since_last = 0;
			}
		}
		else if(NESTER_settings.nes.preferences.StdSpeedState==1 ||NESTER_settings.nes.preferences.StdSpeedState==0){		//FPS
			FramePeriod = StdFramePeriodTime;
			frames_since_last = (uint32)((cur_time - last_frame_time) / FramePeriod );
		}
		else if(NESTER_settings.nes.preferences.StdSpeedState==2){		//SkipFrame
			FramePeriod = StdFramePeriodTime;
			if(skip_frameflag)
			{
				for(i=0;i<NESTER_settings.nes.preferences.StdSkipFrame;++i){
					emulate_frame(FALSE);
					skipframes_this_sec++;
				}
			}
			frames_since_last = 0;
		}

		// are there extra frames?
		if(skip_frameflag){
			if(frames_since_last > 1)
			{
				for(i = 1; i < frames_since_last; i++)
				{
					last_frame_time += FramePeriod;
					emulate_frame(FALSE);
					skipframes_this_sec++;
				}
			}
		}
	}

	// emulate current frame
	PollInput((float)cur_time);
	emulate_frame(TRUE);

	// sleep until this frame's target time
	if(THROTTLE_SPEED)	//THROTTLE_SPEED && !(IsFastFPS)
	{
		if(!(IsFastFPS && NESTER_settings.nes.preferences.FastSpeedState==2))
			SleepUntil(long(last_frame_time+ FramePeriod ));
	}

	// draw frame
	blt();
	flip();

	if(NESTER_settings.nes.preferences.ShowFPS){
		frames_this_sec++;
		if((cur_time - last_profile_sec_time) > (2.0*1000.0)){
			char str[64];
			float cfps, vfps;
			cfps=(float)(frames_this_sec * (1000.0/((double)cur_time - (double)last_profile_sec_time)));
			vfps=(float)((skipframes_this_sec+frames_this_sec) * (1000.0/((double)cur_time - (double)last_profile_sec_time)));
			sprintf(str, "FPS : %5.2f , RFPS : %5.2f", cfps, vfps);
			InfoDisplayt(str, 2000);
			frames_this_sec = 0;
			skipframes_this_sec =0;
			last_profile_sec_time = cur_time;
		}
	}

	// get ready for next frame
	if(THROTTLE_SPEED)	//THROTTLE_SPEED   && !(IsFastFPS)
	{
//		if(!nnnKailleraFlag && !netplay_status)
			last_frame_time += FramePeriod;
/*		else{
			DWORD lcur_time = SYS_TimeInMilliseconds();
			uint32 o = (uint32)((lcur_time - (last_frame_time+FramePeriod)) / FramePeriod );
			if(o > 1){
				last_frame_time  = lcur_time;
			}
			else
				last_frame_time += FramePeriod;
		}
*/
	}
	else
	{
		last_frame_time = cur_time;
	}
	ExtKeyExe();			//Ext Key Function
//	RunFrame_ExtraWindow();
}


// added by Mikami Kana
void win32_GB_emu::shot_screen(char *sfn)
{
	char fn[MAX_PATH];
	if( NESTER_settings.path.UseShotPath )
	{
		strcpy( fn, NESTER_settings.path.szShotPath );
		PathAddBackslash( fn );
	}
	else
		strcpy( fn, getROMpath() );

	if( GetFileAttributes( fn ) == 0xFFFFFFFF )
		MKCreateDirectories( fn );

	strcat( fn, getROMname() );
	int p = strlen(fn);
	for( int i=0; i<=10000; i++ )
	{
		if(NESTER_settings.nes.graphics.ScreenShotUseBmp){
			sprintf( fn + p, "%04d.bmp", i );
		}
		else{
			sprintf( fn + p, "%04d.png", i );
		}
		if( GetFileAttributes( fn ) == 0xFFFFFFFF )
			break;
	}
	if( i >= 10000 )
		return;

	scr_mgr->shot_screen( fn );
	strcpy(sfn, PathFindFileName(fn));
}

// added by Mikami Kana
bool win32_GB_emu::start_sndrec(char *wfn)
{
	if( snd_mgr == &local_null_snd_mgr )
		return FALSE;
	if(wfn!=NULL){
		return snd_mgr->start_sndrec(wfn, NESTER_settings.nes.sound.sample_bits, NESTER_settings.nes.sound.sample_rate );
	}
	char fn[MAX_PATH];
	if( NESTER_settings.path.UseWavePath )
	{
		strcpy( fn, NESTER_settings.path.szWavePath );
		PathAddBackslash( fn );
	}
	else
		strcpy( fn, getROMpath() );

	if( GetFileAttributes( fn ) == 0xFFFFFFFF )
		MKCreateDirectories( fn );

	strcat( fn, getROMname() );
	int p = strlen(fn);
	for( int i=0; i<=100; i++ )
	{
		sprintf( fn + p, "%02d.wav", i );
		if( GetFileAttributes( fn ) == 0xFFFFFFFF )
			break;
	}
	if( i>=100 )
		return FALSE;
	bool result = snd_mgr->start_sndrec(
	                  fn,
	                  NESTER_settings.nes.sound.sample_bits,
	                  NESTER_settings.nes.sound.sample_rate );
	return result;
}

// added by Mikami Kana
void win32_GB_emu::end_sndrec()
{
	snd_mgr->end_sndrec();
}

bool win32_GB_emu::IsRecording()
{
	return snd_mgr->IsRecording();
}

void win32_GB_emu::ToggleFastFPS()
{
	//	if(SKIP_FRAMES)
	{
		if(IsFastFPS){
			last_frame_time = SYS_TimeInMilliseconds();
		}
		IsFastFPS = ~IsFastFPS;
	}
}

uint8 win32_GB_emu::GetDiskSideNum(){
	return 0;
}

uint8 win32_GB_emu::GetDiskSide(){
	return 0;
}

void win32_GB_emu::SetDiskSide(uint8 side){
}

uint8 win32_GB_emu::DiskAccessed(){
	return 0;
}

void win32_GB_emu::SetExControllerType(uint8 num){
//	emu->SetExControllerType(num);
}

uint8 win32_GB_emu::GetExControllerType(){
	return 0;
//	return emu->GetExControllerType();
}

void win32_GB_emu::SetBarcodeValue(uint32 value_low, uint32 value_high){
//	emu->SetBarcodeValue(value_low, value_high);
}

void win32_GB_emu::StopTape(){
//	emu->StopTape();
}

void win32_GB_emu::StartPlayTape(const char* fn){
//	emu->StartPlayTape(fn);
}

void win32_GB_emu::StartRecTape(const char* fn){
//	emu->StartRecTape(fn);
}

uint8 win32_GB_emu::GetTapeStatus(){
	return 0;
//	return emu->GetTapeStatus();
}




//Cheat
void win32_GB_emu::readBaram(unsigned char* adr){
//	emu->readBaram(adr);
}


void win32_GB_emu::writeBaram(unsigned char* adr){
//	emu->writeBaram(adr);
}


void win32_GB_emu::ReadBoneb(unsigned int addr, unsigned char *data){
//	emu->ReadBoneb(addr, data);
}


void win32_GB_emu::WriteBoneb(unsigned int addr, unsigned char data){
//	emu->WriteBoneb(addr, data);
}



//Sram
void win32_GB_emu::readSraram(unsigned char* adr){
//	emu->readSraram(adr);
}

void win32_GB_emu::writeSraram(unsigned char* adr){
//	emu->writeSraram(adr);
}

void win32_GB_emu::ReadSroneb(unsigned int addr, unsigned char *data){
//	emu->ReadSroneb(addr, data);
}


void win32_GB_emu::WriteSroneb(unsigned int addr, unsigned char data){
//	emu->WriteSroneb(addr, data);
}


void win32_GB_emu::GetROMInfoStr(char *wt){
	emu->GetROMInfoStr(wt);
}


void win32_GB_emu::ExtKeyExe(){
	if(!win32_extkey)
		return;
	win32_extkey->Poll();
	if(win32_extkey->Buttonp[0]==1){	//soft reset
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_SOFTRESET, 0);
		win32_extkey->Buttonp[0]=0;
	}
	else if(win32_extkey->Buttonp[0]==2)
		win32_extkey->Buttonp[0]=0;
	if(win32_extkey->Buttonp[1]==1){		//Hard Reset
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_RESET, 0);
		win32_extkey->Buttonp[1]=0;
	}
	else if(win32_extkey->Buttonp[1]==2)
		win32_extkey->Buttonp[1]=0;
	if(win32_extkey->Buttonp[2]==1){		// FDS side change
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_USEEXTKEY4, 0);
		win32_extkey->Buttonp[2]=0;
	}
	else if(win32_extkey->Buttonp[2]==2)
		win32_extkey->Buttonp[2]=0;
	if(win32_extkey->Buttonp[3]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_DISK_1A, 0);
		win32_extkey->Buttonp[3]=0;
	}
	else if(win32_extkey->Buttonp[3]==2)
		win32_extkey->Buttonp[3]=0;
	if(win32_extkey->Buttonp[4]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_DISK_1B, 0);
		win32_extkey->Buttonp[4]=0;
	}
	else if(win32_extkey->Buttonp[4]==2)
		win32_extkey->Buttonp[4]=0;
	if(win32_extkey->Buttonp[5]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_DISK_2A, 0);
		win32_extkey->Buttonp[5]=0;
	}
	else if(win32_extkey->Buttonp[5]==2)
		win32_extkey->Buttonp[5]=0;
	if(win32_extkey->Buttonp[6]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_DISK_2B, 0);
		win32_extkey->Buttonp[6]=0;
	}
	else if(win32_extkey->Buttonp[6]==2)
		win32_extkey->Buttonp[6]=0;
	if(win32_extkey->Buttonp[7]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_DISK_EJECT, 0);
		win32_extkey->Buttonp[7]=0;
	}
	else if(win32_extkey->Buttonp[7]==2)
		win32_extkey->Buttonp[7]=0;

	if(win32_extkey->Buttonp[9]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_USEEXTKEY1, 0);
		win32_extkey->Buttonp[9]=0;
	}
	else if(win32_extkey->Buttonp[9]==2){
		if(!NESTER_settings.nes.input.extkeycfgFastFPSToggle)
			SendMessage(parent_wnd_handle, WM_COMMAND, ID_USEEXTKEY1, 0);
		win32_extkey->Buttonp[9]=0;
	}
	if(win32_extkey->Buttonp[10]==1){		//Fast Speed (Toggle)
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_USEEXTKEY1, 0);
		win32_extkey->Buttonp[10]=0;
	}
	else if(win32_extkey->Buttonp[0x10]==2)
		win32_extkey->Buttonp[10]=0;
	if(win32_extkey->Buttonp[11]==1){		//Pause
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_USEEXTKEY5, 0);
		win32_extkey->Buttonp[11]=0;
	}
	else if(win32_extkey->Buttonp[11]==2)
		win32_extkey->Buttonp[11]=0;
	if(win32_extkey->Buttonp[12]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_SCREENSHOT, 0);
		win32_extkey->Buttonp[12]=0;
	}
	else if(win32_extkey->Buttonp[12]==2)
		win32_extkey->Buttonp[12]=0;
	if(win32_extkey->Buttonp[13]==1){		//Screen Shot (While pushing)
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_SCREENSHOT, 0);
	}
	else if(win32_extkey->Buttonp[13]==2)
		win32_extkey->Buttonp[13]=0;
	if(win32_extkey->Buttonp[14]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_SNDREC, 0);
		win32_extkey->Buttonp[14]=0;
	}
	else if(win32_extkey->Buttonp[14]==2)
		win32_extkey->Buttonp[14]=0;
	if(win32_extkey->Buttonp[15]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_OPTIONS_FULLSCREEN, 0);
		win32_extkey->Buttonp[15]=0;
	}
	else if(win32_extkey->Buttonp[15]==2)
		win32_extkey->Buttonp[15]=0;

	if(win32_extkey->Buttonp[0x10]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_QUICK_SAVE, 0);
		win32_extkey->Buttonp[0x10]=0;
	}
	else if(win32_extkey->Buttonp[0x10]==2)
		win32_extkey->Buttonp[0x10]=0;
	if(win32_extkey->Buttonp[0x11]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_QUICK_LOAD, 0);
		win32_extkey->Buttonp[0x11]=0;
	}
	else if(win32_extkey->Buttonp[0x11]==2)
		win32_extkey->Buttonp[0x11]=0;
	if(win32_extkey->Buttonp[0x12]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_USEEXTKEY2, 0);
		win32_extkey->Buttonp[0x12]=0;
	}
	else if(win32_extkey->Buttonp[0x12]==2)
		win32_extkey->Buttonp[0x12]=0;
	if(win32_extkey->Buttonp[0x13]==1){
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_USEEXTKEY3, 0);
		win32_extkey->Buttonp[0x13]=0;
	}
	else if(win32_extkey->Buttonp[0x13]==2)
		win32_extkey->Buttonp[0x13]=0;

	if(win32_extkey->Buttonp[0x14]==1){		//FPS Display(Toggle)
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_CHEATFPS, 0);
		win32_extkey->Buttonp[0x14]=0;
	}
	else if(win32_extkey->Buttonp[0x14]==2)
		win32_extkey->Buttonp[0x14]=0;
	if(win32_extkey->Buttonp[0x15]==1){		//Cheat Apply Flag reverse(Toggle)
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_CHEAP_CHEAT2, 0);
		win32_extkey->Buttonp[0x15]=0;
	}
	else if(win32_extkey->Buttonp[0x15]==2)
		win32_extkey->Buttonp[0x15]=0;
	if(win32_extkey->Buttonp[0x16]==1){		//Launcher
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_CHEAP_CHEAT7, 0);
		win32_extkey->Buttonp[0x16]=0;
	}
	else if(win32_extkey->Buttonp[0x16]==2)
		win32_extkey->Buttonp[0x16]=0;
	if(win32_extkey->Buttonp[0x17]==1){		//Movie Stop.
		SendMessage(parent_wnd_handle, WM_COMMAND, ID_FILE_MOVIE_STOP, 0);
		win32_extkey->Buttonp[0x17]=0;
	}
	else if(win32_extkey->Buttonp[0x17]==2)
		win32_extkey->Buttonp[0x17]=0;
	return;
}


unsigned char win32_GB_emu::GetScreenMode(){
	return 0;
//	return emu->GetScreenMode();
}

void win32_GB_emu::nnnKailleraClient(){	//nnn
//	emu->nnnKailleraClient();
	return;
}

void win32_GB_emu::nnnManuEnable(unsigned char flag){
	scr_mgr->nnnManuEnable(flag);
}

/*
void win32_GB_emu::SetScreenmgr(){
	scr_mgr->SetScreenmgr();
}
*/

void win32_GB_emu::SetFrameSpeed(){
	if(NESTER_settings.nes.preferences.StdSpeedState==0){
		if(1==emu->GetScreenMode()){
			StdFramePeriodTime = 1000.0/NTSC_FRAMERATE;
		}
		else{
			StdFramePeriodTime = 1000.0/PAL_FRAMERATE;
		}
	}
	else if(NESTER_settings.nes.preferences.StdSpeedState==1){
		StdFramePeriodTime = 1000.0/NESTER_settings.nes.preferences.StdFPS;
	}
	else{
		float tf;
		if(1==emu->GetScreenMode())
			tf = (float)NTSC_FRAMERATE;
		else
			tf = (float)PAL_FRAMERATE;
		StdFramePeriodTime = 1000.0/((NESTER_settings.nes.preferences.StdSkipFrame+1)*tf);
	}
	if(NESTER_settings.nes.preferences.FastSpeedState==0){
		FastFramePeriodTime= 1000.0/NESTER_settings.nes.preferences.FastFPS;
	}
	else if(NESTER_settings.nes.preferences.FastSpeedState==1){
		float tf;
		if(1==emu->GetScreenMode())
			tf = (float)NTSC_FRAMERATE;
		else
			tf = (float)PAL_FRAMERATE;
		FastFramePeriodTime = 1000.0/((NESTER_settings.nes.preferences.FastSkipFrame+1)*tf);
	}
	else{
		FastFramePeriodTime = 0;
	}
}


#endif
