
#ifndef _NNN_ASPI_H_
#define _NNN_ASPI_H_

#pragma pack(1)

struct TOC_TRACK {
	BYTE Reserved;
	BYTE ADR;			// bit7-4 = ADR,  bit3-0 = CONTROL
	/*
	Table 294 - ADR Q Sub-channel field
	ADR Code Description
	0h Q Sub-channel mode information not supplied
	1h Q Sub-channel encodes current position data
	(i.e., track, index, absolute address, relative address)
	2h Q Sub-channel encodes media catalog number
	3h Q Sub-channel encodes ISRC
	4h - Fh Reserved
	  */
	BYTE nTrack;
	BYTE Reserved2;
	BYTE LBA[4];		// Logical Block Address   ( [0]MSB - [3]LSB )
};

struct TOC {
	WORD TOC_Len;		// TOC Data Length
	BYTE nFirstTrack;	// First Track Number
	BYTE nLastTrack;	// Last Track Number
	struct TOC_TRACK TrackInfo[100];
};
#pragma pack()


struct nnn_cddrive_info {
	int		HostID;
	int		DeviceID;
	char	HostAdapterName[16];
	char	VendorIDName[8];
	char	ProductIDName[16];
	char	ProductVerName[4];

};



int InitASPIDLL();
void ReleaseASPIDLL();
int ASPI_GetDriveInfo(struct nnn_cddrive_info *driveinfo);
void EnumCDROMDevice();
void FreeCDROMDeviceInfo();
int ASPI_CheckMediaReady(struct nnn_cddrive_info *driveinfo);











#endif